Index: trunk/sources/HeuristicLab.Tests/Builder.testsettings
===================================================================
--- trunk/sources/HeuristicLab.Tests/Builder.testsettings	(revision 7542)
+++ trunk/sources/HeuristicLab.Tests/Builder.testsettings	(revision 7558)
@@ -110,14 +110,20 @@
     <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.TravelingSalesman-3.3.dll" />
     <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Parameters.Views-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Algorithms.Benchmarks.Views-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Algorithms.Benchmarks-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Hive-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive-3.3.dll" />	
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive.Administrator-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive.JobManager-3.3" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive.Views-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive-3.3.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.DayView-1.0.dll" />
-	<DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.MathJax-1.1.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Algorithms.Benchmarks.Views-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Algorithms.Benchmarks-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Hive-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive-3.3.dll" />	
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive.Administrator-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive.JobManager-3.3" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive.Views-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Clients.Hive-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.DayView-1.0.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.MathJax-1.1.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.Instances-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.Instances.TSPLIB-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.Instances.QAPLIB-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.Instances.CordeauGQAP-3.3.dll" />
+    <DeploymentItem filename="HeuristicLab.Tests\bin\Release\HeuristicLab.Problems.Instances.TSPLIB.Views-3.3.dll" />
   </Deployment>
   <Execution hostProcessPlatform="MSIL">
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Resources/ch130.opt.tour
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Resources/ch130.opt.tour	(revision 7542)
+++ 	(revision )
@@ -1,136 +1,0 @@
-NAME : ch130.opt.tour
-COMMENT : Length 6110
-TYPE : TOUR
-DIMENSION : 130
-TOUR_SECTION
-1
-41
-39
-117
-112
-115
-28
-62
-105
-128
-16
-45
-5
-11
-76
-109
-61
-129
-124
-64
-69
-86
-88
-26
-7
-97
-70
-107
-127
-104
-43
-34
-17
-31
-27
-19
-100
-15
-29
-24
-116
-95
-79
-87
-12
-81
-103
-77
-94
-89
-110
-98
-68
-63
-48
-25
-113
-32
-36
-84
-119
-111
-123
-101
-82
-57
-9
-56
-65
-52
-75
-74
-99
-73
-92
-38
-106
-53
-120
-58
-49
-72
-91
-6
-102
-10
-14
-67
-13
-96
-122
-55
-60
-51
-42
-44
-93
-37
-22
-47
-40
-23
-33
-21
-126
-121
-78
-66
-85
-125
-90
-59
-30
-83
-3
-114
-108
-8
-18
-46
-80
-118
-20
-4
-35
-54
-2
-50
-130
-71
--1
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Resources/ch130.tsp
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Resources/ch130.tsp	(revision 7542)
+++ 	(revision )
@@ -1,137 +1,0 @@
-NAME: ch130
-TYPE: TSP
-COMMENT: 130 city problem (Churritz)
-DIMENSION: 130
-EDGE_WEIGHT_TYPE: EUC_2D
-NODE_COORD_SECTION
-1 334.5909245845 161.7809319139
-2 397.6446634067 262.8165330708
-3 503.8741827107 172.8741151168
-4 444.0479403502 384.6491809647
-5 311.6137146746 2.0091699828
-6 662.8551011379 549.2301263653
-7 40.0979030612 187.2375430791
-8 526.8941409181 215.7079092185
-9 209.1887938487 691.0262291948
-10 683.2674131973 414.2096286906
-11 280.7494438748 5.9206392047
-12 252.7493090080 535.7430385019
-13 698.7850451923 348.4413729766
-14 678.7574678104 410.7256424438
-15 220.0041131179 409.1225812873
-16 355.1528556851 76.3912076444
-17 296.9724227786 313.1312792361
-18 504.5154071733 240.8866564499
-19 224.1079496785 358.4872228907
-20 470.6801296968 309.6259188406
-21 554.2530513223 279.4242466521
-22 567.6332684419 352.7162027273
-23 599.0532671093 361.0948690386
-24 240.5232959211 430.6036007844
-25 32.0825972787 345.8551009775
-26 91.0538736891 148.7213270256
-27 248.2179894723 343.9528017384
-28 488.8909044347 3.6122311393
-29 206.0467939820 437.7639406167
-30 575.8409415632 141.9670960195
-31 282.6089948164 329.4183805862
-32 27.6581484868 424.7684581747
-33 568.5737309870 287.0975660546
-34 269.4638933331 295.9464636385
-35 417.8004856811 341.2596589955
-36 32.1680938737 448.8998721172
-37 561.4775136009 357.3543930067
-38 342.9482167470 492.3321423839
-39 399.6752075383 156.8435035519
-40 571.7371050025 375.7575350833
-41 370.7559842751 151.9060751898
-42 509.7093253204 435.7975189314
-43 177.0206999750 295.6044772584
-44 526.1674198605 409.4859418161
-45 316.5725171854 65.6400108214
-46 469.2908100279 281.9891445025
-47 572.7630641427 373.3208821255
-48 29.5176994283 330.0382309000
-49 454.0082936692 537.2178547659
-50 416.1546762271 227.6133100741
-51 535.2514330806 471.0648643744
-52 265.4455533675 684.9987192464
-53 478.0542110167 509.6452028741
-54 370.4781203413 332.5390063041
-55 598.3479202004 446.8693279856
-56 201.1521139175 649.0260268945
-57 193.6925360026 680.2322840744
-58 448.5792598859 532.7934059740
-59 603.2853485624 134.4006473609
-60 543.0102490781 481.5168231148
-61 214.5750793346 43.6460117543
-62 426.3501451825 61.7285415996
-63 89.0447037063 277.1158385868
-64 84.4920100219 31.8474816424
-65 220.0468614154 623.0778103080
-66 688.4613313444 0.4702312726
-67 687.2857531630 373.5346236130
-68 75.4934933967 312.9175377486
-69 63.4170993511 23.7039309674
-70 97.9363495877 211.0910930878
-71 399.5255884970 170.8221968365
-72 456.3167017346 597.1937161677
-73 319.8855102422 626.8396604886
-74 295.9250894897 664.6291554845
-75 288.4868857235 667.7284070537
-76 268.3951858954 52.9010181645
-77 140.4709056068 513.5566720960
-78 689.8079027159 167.5947003748
-79 280.5784506848 458.7533546925
-80 453.3884433554 282.9082328989
-81 213.5704943432 525.8681817779
-82 133.6953004520 677.1757808026
-83 521.1658690522 132.8617086506
-84 30.2657946347 450.0754502986
-85 657.0199585283 39.7772908299
-86 6.9252241961 23.8749241575
-87 252.4286967767 535.1659364856
-88 42.8551682504 63.8232081774
-89 145.8999393902 399.5255884970
-90 638.4885715591 62.6262558472
-91 489.2756391122 665.3131282446
-92 361.2231139311 564.2347787901
-93 519.9475425732 347.9711417040
-94 129.3349741063 435.6692740389
-95 259.7172815016 454.6495181318
-96 676.3421890013 371.0979706551
-97 84.5133841706 183.3260738572
-98 77.7164048671 354.3833863300
-99 335.9802442534 660.6321896676
-100 264.3554717810 377.5743377274
-101 51.6826916855 676.0429509187
-102 692.1376849300 543.8010925819
-103 169.2191356800 547.8194325476
-104 194.0131482339 263.4791316822
-105 415.1928395332 78.9133571973
-106 415.0432204919 479.0801701569
-107 169.8389859939 245.6103433244
-108 525.0987124228 213.5063718969
-109 238.6851191283 33.4932910965
-110 116.2112467718 363.5742702940
-111 16.9283258126 656.5711014044
-112 434.3440768162 92.6996831431
-113 40.5253860363 424.6829615797
-114 530.4849979086 183.8390534273
-115 484.3595848990 49.2460387276
-116 263.6501248722 426.5852608187
-117 450.2891917862 126.3853415784
-118 441.7822805823 299.7724362653
-119 24.2169105375 500.3474481664
-120 503.7886861157 514.6895019799
-121 635.5389390312 200.9811207275
-122 614.5922732529 418.8691931188
-123 21.7161351334 660.9741760476
-124 143.8266469611 92.6996831431
-125 637.7191022040 54.2048412384
-126 566.5645610042 199.9551615873
-127 196.6849168280 221.8209157619
-128 384.9270448985 87.4630166986
-129 178.1107815614 104.6905805938
-130 403.2874386776 205.8971749407
-EOF
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 7542)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 7558)
@@ -44,4 +44,5 @@
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Classification;
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.Instances.TSPLIB;
 using HeuristicLab.Problems.Knapsack;
 using HeuristicLab.Problems.TestFunctions;
@@ -56,6 +57,4 @@
   [TestClass]
   [DeploymentItem(@"HeuristicLab-3.3/Resources/C101.opt.txt")]
-  [DeploymentItem(@"HeuristicLab-3.3/Resources/ch130.tsp")]
-  [DeploymentItem(@"HeuristicLab-3.3/Resources/ch130.opt.tour")]
   [DeploymentItem(@"HeuristicLab-3.3/Resources/mammographic_masses.txt")]
   [DeploymentItem(@"HeuristicLab-3.3/Resources/towerData.txt")]
@@ -83,11 +82,9 @@
       GeneticAlgorithm ga = new GeneticAlgorithm();
       #region Problem Configuration
+      var provider = new TSPLIBTSPInstanceProvider();
+      var instance = provider.GetDataDescriptors().Where(x => x.Name == "ch130").Single();
       TravelingSalesmanProblem tspProblem = new TravelingSalesmanProblem();
-      tspProblem.ImportFromTSPLIB("ch130.tsp", "ch130.opt.tour", 6110);
-      tspProblem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
-      tspProblem.SolutionCreatorParameter.Value = new RandomPermutationCreator();
+      tspProblem.Load(provider.LoadData(instance));
       tspProblem.UseDistanceMatrix.Value = true;
-      tspProblem.Name = "ch130 TSP (imported from TSPLIB)";
-      tspProblem.Description = "130 city problem (Churritz)";
       #endregion
       #region Algorithm Configuration
@@ -511,11 +508,9 @@
       IslandGeneticAlgorithm ga = new IslandGeneticAlgorithm();
       #region Problem Configuration
+      var provider = new TSPLIBTSPInstanceProvider();
+      var instance = provider.GetDataDescriptors().Where(x => x.Name == "ch130").Single();
       TravelingSalesmanProblem tspProblem = new TravelingSalesmanProblem();
-      tspProblem.ImportFromTSPLIB("ch130.tsp", "ch130.opt.tour", 6110);
-      tspProblem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
-      tspProblem.SolutionCreatorParameter.Value = new RandomPermutationCreator();
+      tspProblem.Load(provider.LoadData(instance));
       tspProblem.UseDistanceMatrix.Value = true;
-      tspProblem.Name = "ch130 TSP (imported from TSPLIB)";
-      tspProblem.Description = "130 city problem (Churritz)";
       #endregion
       #region Algorithm Configuration
@@ -766,11 +761,9 @@
       TabuSearch ts = new TabuSearch();
       #region Problem Configuration
-      var tspProblem = new TravelingSalesmanProblem();
-      tspProblem.ImportFromTSPLIB("ch130.tsp", "ch130.opt.tour", 6110);
-      tspProblem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
-      tspProblem.SolutionCreatorParameter.Value = new RandomPermutationCreator();
+      var provider = new TSPLIBTSPInstanceProvider();
+      var instance = provider.GetDataDescriptors().Where(x => x.Name == "ch130").Single();
+      TravelingSalesmanProblem tspProblem = new TravelingSalesmanProblem();
+      tspProblem.Load(provider.LoadData(instance));
       tspProblem.UseDistanceMatrix.Value = true;
-      tspProblem.Name = "ch130 TSP (imported from TSPLIB)";
-      tspProblem.Description = "130 city problem (Churritz)";
       #endregion
       #region Algorithm Configuration
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.QuadraticAssignment-3.3/QAPLIBInstancesTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.QuadraticAssignment-3.3/QAPLIBInstancesTest.cs	(revision 7542)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.QuadraticAssignment-3.3/QAPLIBInstancesTest.cs	(revision 7558)
@@ -24,6 +24,6 @@
 using System.IO;
 using System.Linq;
-using System.Reflection;
 using System.Text;
+using HeuristicLab.Problems.Instances.QAPLIB;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
@@ -31,47 +31,159 @@
   [TestClass]
   public class QAPLIBInstancesTest {
-    private static string InstancePrefix = "HeuristicLab.Tests.HeuristicLab.Problems.QuadraticAssignment_3._3.QAPLIB.";
-
-    private IEnumerable<string> EmbeddedInstances {
-      get {
-        return Assembly.GetExecutingAssembly()
-          .GetManifestResourceNames()
-          .Where(x => x.EndsWith(".dat"))
-          .OrderBy(x => x)
-          .Select(x => x.Replace(".dat", String.Empty))
-          .Select(x => x.Replace(InstancePrefix, String.Empty));
-      }
-    }
+    #region instances
+    private static Dictionary<string, double> qaplibInstances = new Dictionary<string, double>() {
+      { "bur26a", 5426670 },
+      { "bur26b", 3817852 },
+      { "bur26c", 5426795 },
+      { "bur26d", 3821225 },
+      { "bur26e", 5386879 },
+      { "bur26f", 3782044 },
+      { "bur26g", 10117172 },
+      { "bur26h", 7098658 },
+      { "chr12a", 9552 },
+      { "chr12b", 9742 },
+      { "chr12c", 11156 },
+      { "chr15a", 9896 },
+      { "chr15b", 7990 },
+      { "chr15c", 9504 },
+      { "chr18a", 11098 },
+      { "chr18b", 1534 },
+      { "chr20a", 2192 },
+      { "chr20b", 2298 },
+      { "chr20c", 14142 },
+      { "chr22a", 6156 },
+      { "chr22b", 6194 },
+      { "chr25a", 3796 },
+      { "els19", 17212548 },
+      { "esc16a", 68 },
+      { "esc16b", 292 },
+      { "esc16c", 160 },
+      { "esc16d", 16 },
+      { "esc16e", 28 },
+      { "esc16f", 0 },
+      { "esc16g", 26 },
+      { "esc16h", 996 },
+      { "esc16i", 14 },
+      { "esc16j", 8 },
+      { "esc32a", 130 },
+      { "esc32b", 168 },
+      { "esc32c", 642 },
+      { "esc32d", 200 },
+      { "esc32e", 2 },
+      { "esc32f", 2 },
+      { "esc32g", 6 },
+      { "esc32h", 438 },
+      { "esc64", 116 },
+      { "esc128", 64 },
+      { "had12", 1652 },
+      { "had14", 2724 },
+      { "had16", 3720 },
+      { "had18", 5358 },
+      { "had20", 6922 },
+      { "kra30a", 88900 },
+      { "kra30b", 91420 },
+      { "kra32", 88700 },
+      { "lipa20a", 3683 },
+      { "lipa20b", 27076 },
+      { "lipa30a", 13178 },
+      { "lipa30b", 151426 },
+      { "lipa40a", 31538 },
+      { "lipa40b", 476581 },
+      { "lipa50a", 62093 },
+      { "lipa50b", 1210244 },
+      { "lipa60a", 107218 },
+      { "lipa60b", 2520135 },
+      { "lipa70a", 169755 },
+      { "lipa70b", 4603200 },
+      { "lipa80a", 253195 },
+      { "lipa80b", 7763962 },
+      { "lipa90a", 360630 },
+      { "lipa90b", 12490441 },
+      { "nug12", 578 },
+      { "nug14", 1014 },
+      { "nug15", 1150 },
+      { "nug16a", 1610 },
+      { "nug16b", 1240 },
+      { "nug17", 1732 },
+      { "nug18", 1930 },
+      { "nug20", 2570 },
+      { "nug21", 2438 },
+      { "nug22", 3596 },
+      { "nug24", 3488 },
+      { "nug25", 3744 },
+      { "nug27", 5234 },
+      { "nug28", 5166 },
+      { "nug30", 6124 },
+      { "rou12", 235528 },
+      { "rou15", 354210 },
+      { "rou20", 725522 },
+      { "scr12", 31410 },
+      { "scr15", 51140 },
+      { "scr20", 110030 },
+      { "sko42", 15812 },
+      { "sko49", 23386 },
+      { "sko56", 34458 },
+      { "sko64", 48498 },
+      { "sko72", 66256 },
+      { "sko81", 90998 },
+      { "sko90", 115534 },
+      { "sko100a", 152002 },
+      { "sko100b", 153890 },
+      { "sko100c", 147862 },
+      { "sko100d", 149576 },
+      { "sko100e", 149150 },
+      { "sko100f", 149036 },
+      { "ste36a", 9526 },
+      { "ste36b", 15852 },
+      { "ste36c", 8239110 },
+      { "tai12a", 224416 },
+      { "tai12b", 39464925 },
+      { "tai15a", 388214 },
+      { "tai15b", 51765268 },
+      { "tai17a", 491812 },
+      { "tai20a", 703482 },
+      { "tai20b", 122455319 },
+      { "tai25a", 1167256 },
+      { "tai25b", 344355646 },
+      { "tai30a", 1818146 },
+      { "tai30b", 637117113 },
+      { "tai35a", 2422002 },
+      { "tai35b", 283315445 },
+      { "tai40a", 3139370 },
+      { "tai40b", 637250948 },
+      { "tai50a", 4938796 },
+      { "tai50b", 458821517 },
+      { "tai60a", 7208572  },
+      { "tai60b", 608215054 },
+      { "tai64c", 1855928 },
+      { "tai80a", 13557864 },
+      { "tai80b", 818415043 },
+      { "tai100a", 21052466 },
+      { "tai100b", 1185996137 },
+      { "tai150b", 498896643 },
+      { "tai256c", 44759294 },
+      { "tho30", 149936 },
+      { "tho40", 240516 },
+      { "tho150", 8133398 },
+      { "wil50", 48816 },
+      { "wil100", 273038 }
+    };
+    #endregion
 
     [TestMethod]
     public void TestQAPLIBInstances() {
+      var provider = new QAPLIBInstanceProvider();
       var qap = new QuadraticAssignmentProblem();
       var failedInstances = new StringBuilder();
       string tempPath = Path.GetTempPath();
 
-      Assert.IsTrue(EmbeddedInstances.Any(), "No instances could be found.");
-
-      foreach (string instance in EmbeddedInstances) {
-        WriteEmbeddedResourceToFile(InstancePrefix + instance + ".dat", File.Create(Path.Combine(tempPath, "instance.dat")));
-
-        bool solutionExists = Assembly.GetExecutingAssembly().GetManifestResourceNames().Any(x => x == InstancePrefix + instance + ".sln");
-        if (solutionExists)
-          WriteEmbeddedResourceToFile(InstancePrefix + instance + ".sln", File.Create(Path.Combine(tempPath, "instance.sln")));
-
+      var instances = provider.GetDataDescriptors();
+      Assert.IsTrue(instances.Any(), "No instances could be found.");
+
+      foreach (var instance in instances) {
         try {
-          qap.LoadInstanceFromFile(Path.Combine(tempPath, "instance.dat"));
+          qap.Load(provider.LoadData(instance));
         } catch (Exception ex) {
           failedInstances.AppendLine(instance + ": " + ex.Message);
-          solutionExists = false; // not necessary to test solution as well
-        }
-
-        if (solutionExists) {
-          try {
-            qap.LoadInstanceFromFile(Path.Combine(tempPath, "instance.dat"), Path.Combine(tempPath, "instance.sln"));
-            if (qap.BestKnownSolution == null)
-              failedInstances.AppendLine(instance + " (sln): Given solution and reported quality cannot be reproduced.");
-          } catch (Exception ex) {
-            failedInstances.AppendLine(instance + " (+sln):" + ex.Message);
-          }
         }
       }
@@ -79,13 +191,21 @@
     }
 
-    private void WriteEmbeddedResourceToFile(string resource, FileStream file) {
-      try {
-        using (Stream stream = Assembly.GetExecutingAssembly().GetManifestResourceStream(resource)) {
-          int token;
-          while ((token = stream.ReadByte()) >= 0) {
-            file.WriteByte((byte)token);
-          }
-        }
-      } finally { file.Close(); }
+    [TestMethod]
+    public void TestQAPLIBSolutions() {
+      var provider = new QAPLIBInstanceProvider();
+      var qap = new QuadraticAssignmentProblem();
+      var failedInstances = new StringBuilder();
+      string tempPath = Path.GetTempPath();
+
+      var instances = provider.GetDataDescriptors();
+      Assert.IsTrue(instances.Any(), "No instances could be found.");
+
+      foreach (var instance in instances) {
+        qap.Load(provider.LoadData(instance));
+        if (qaplibInstances.ContainsKey(instance.Name)
+          && qap.BestKnownQuality != null && qap.BestKnownQuality.Value != qaplibInstances[instance.Name])
+          failedInstances.AppendLine(instance.Name + ": " + qap.BestKnownQuality.Value.ToString() + " vs " + qaplibInstances[instance.Name]);
+      }
+      Assert.IsTrue(failedInstances.Length == 0, "Following instances/solutions have suspicious quality: " + Environment.NewLine + failedInstances.ToString());
     }
   }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 7542)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 7558)
@@ -293,10 +293,4 @@
     <None Include="app.config" />
     <None Include="Builder.testsettings" />
-    <None Include="HeuristicLab-3.3\Resources\ch130.opt.tour">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="HeuristicLab-3.3\Resources\ch130.tsp">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
     <None Include="HeuristicLab-3.3\Resources\GA_SymbReg.hl">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
@@ -308,141 +302,4 @@
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26d.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26e.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26f.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26g.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26h.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr12a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr12b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr12c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr15a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr15b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr15c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr18a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr18b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr20a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr20b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr20c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr22a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr22b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr25a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\els19.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc128.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16d.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16e.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16f.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16g.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16h.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16i.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16j.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32d.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32e.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32f.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32g.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32h.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc64a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had12.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had14.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had16.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had18.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had20.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\kra30a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\kra30b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\kra32.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa20a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa20b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa30a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa30b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa40a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa40b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa50a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa50b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa60a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa60b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa70a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa70b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa80a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa80b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa90a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa90b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug12.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug14.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug15.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug16a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug16b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug17.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug18.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug20.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug21.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug22.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug24.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug25.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug27.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug28.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug30.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\rou12.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\rou15.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\rou20.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\scr12.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\scr15.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\scr20.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100d.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100e.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100f.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko42.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko49.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko56.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko64.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko72.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko81.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko90.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\ste36a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\ste36b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\ste36c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai100a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai100b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai10a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai10b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai12a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai12b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai150b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai15a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai15b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai17a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai20a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai20b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai256c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai25a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai25b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai30a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai30b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai35a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai35b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai40a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai40b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai50a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai50b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai60a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai60b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai64c.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai80a.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai80b.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tho150.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tho30.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tho40.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\wil100.dat" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\wil50.dat" />
     <None Include="HeuristicLab.snk" />
     <Shadow Include="Test References\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.accessor" />
@@ -468,125 +325,4 @@
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26d.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26e.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26f.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26g.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\bur26h.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr12a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr12b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr12c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr15a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr15b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr15c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr18a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr18b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr20a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr20b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr20c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr22a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr22b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\chr25a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\els19.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc128.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16d.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16e.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16f.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16g.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16h.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16i.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc16j.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32e.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32f.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\esc32g.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had12.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had14.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had16.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had18.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\had20.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\kra30a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\kra30b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\kra32.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa20a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa20b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa30a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa30b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa40a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa40b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa50a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa50b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa60a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa60b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa70a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa70b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa80a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa80b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa90a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\lipa90b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug12.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug14.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug15.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug16a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug16b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug17.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug18.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug20.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug21.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug22.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug24.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug25.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug27.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug28.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\nug30.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\rou12.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\rou15.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\rou20.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\scr12.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\scr15.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\scr20.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100d.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100e.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko100f.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko49.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko81.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\sko90.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\ste36a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\ste36b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\ste36c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai100a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai100b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai12a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai12b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai150b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai15a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai15b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai17a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai20a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai20b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai256c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai25a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai25b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai30b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai35b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai40b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai50a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai50b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai60a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai60b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai64c.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai80a.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tai80b.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tho150.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\tho30.sln" />
-    <EmbeddedResource Include="HeuristicLab.Problems.QuadraticAssignment-3.3\QAPLIB\wil100.sln" />
   </ItemGroup>
   <ItemGroup>
@@ -859,4 +595,28 @@
       <Name>HeuristicLab.Problems.ExternalEvaluation-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.Instances.CordeauGQAP\3.3\HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj">
+      <Project>{1F2718DA-BF13-40EE-A7FD-EEDB4912E64E}</Project>
+      <Name>HeuristicLab.Problems.Instances.CordeauGQAP-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.Instances.ElloumiCTAP\3.3\HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj">
+      <Project>{CCF61DA0-B226-4C0F-8052-29ACC6BDE6EE}</Project>
+      <Name>HeuristicLab.Problems.Instances.ElloumiCTAP-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.Instances.QAPLIB\3.3\HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj">
+      <Project>{73F29D43-5714-4069-8FAB-0D18FEB5F175}</Project>
+      <Name>HeuristicLab.Problems.Instances.QAPLIB-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.Instances.TSPLIB.Views\3.3\HeuristicLab.Problems.Instances.TSPLIB.Views-3.3.csproj">
+      <Project>{8B2BC81F-6B6C-414D-A934-57FD3FA8D6DC}</Project>
+      <Name>HeuristicLab.Problems.Instances.TSPLIB.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.Instances.TSPLIB\3.3\HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj">
+      <Project>{CE0F99D6-1C56-48A9-9B68-3E5B833703EF}</Project>
+      <Name>HeuristicLab.Problems.Instances.TSPLIB-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj">
+      <Project>{3540E29E-4793-49E7-8EE2-FEA7F61C3994}</Project>
+      <Name>HeuristicLab.Problems.Instances-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.Problems.Knapsack.Views\3.3\HeuristicLab.Problems.Knapsack.Views-3.3.csproj">
       <Project>{A9EE65D9-405B-4C9C-B470-FC911AAC541B}</Project>
@@ -932,5 +692,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup />
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
